import es

info = es.AddonInfo()
info.name = "Python event call modifier"
info.basename = "modevents"
info.version = "alpha"
info.description = "Allows modifying event variables for Python addon event calls"
info.url = "http://addons.eventscripts.com/addons/view/modevents"

hookers = {}

es.ServerVar('modevents_py', info.version, '%s version'%info.name).makepublic()

class FakeEventVariables(dict):
    def __getitem__(self, key):
        if key in self:
            return super(FakeEventVariables, self).__getitem__(key)
        else:
            return es.getEventInfo(key)

def fake_triggerEvent(self, eventname):
    """ A replacement for es.addons.triggerEvent """
    if not self.EventListeners.has_key(eventname):
        return
    event_var = FakeEventVariables()
    if eventname in hookers:
        for hacker in hookers[eventname]:
            hacker(event_var)
    for listener in self.EventListeners[eventname]:
        if not listener.__dict__.has_key('disable') or not listener.disabled:
            try:
                self.EventListeners[eventname][listener](event_var)
            except:
                es.excepter(*es.sys.exc_info())

original_triggerEvent = es.addons.triggerEvent
es.addons.triggerEvent = fake_triggerEvent

def add_modder(eventname, callback):
    if eventname not in hookers:
        hookers[eventname] = set()
    hookers[eventname].add(callback)

def del_modder(eventname, callback):
    hookers[eventname].remove(callback)
